package dev.shadowsoffire.apotheosis.ench;

import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import dev.shadowsoffire.apotheosis.ench.enchantments.corrupted.BerserkersFuryEnchant;
import net.minecraftforge.event.entity.living.LivingHurtEvent;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.inventory.AbstractContainerMenu;
import dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile;
import net.minecraft.world.inventory.AnvilMenu;
import dev.shadowsoffire.apotheosis.ench.enchantments.NaturesBlessingEnchant;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.ChainsawEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.EarthsBoonEnchant;
import net.minecraftforge.event.level.BlockEvent;
import dev.shadowsoffire.apotheosis.ench.enchantments.twisted.MinersFervorEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.StableFootingEnchant;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.entity.projectile.ThrownTrident;
import net.minecraftforge.event.entity.living.LootingLevelEvent;
import dev.shadowsoffire.apotheosis.ench.enchantments.ReflectiveEnchant;
import net.minecraftforge.event.entity.living.ShieldBlockEvent;
import dev.shadowsoffire.apotheosis.ench.enchantments.corrupted.LifeMendingEnchant;
import net.minecraft.world.entity.EntityType;
import net.minecraftforge.event.entity.living.LivingHealEvent;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.KnowledgeEnchant;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraft.world.entity.Entity;
import dev.shadowsoffire.apotheosis.ench.enchantments.SpearfishingEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.ScavengerEnchant;
import net.minecraft.world.entity.player.Player;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.event.entity.player.AnvilRepairEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import dev.shadowsoffire.apotheosis.ench.objects.ExtractionTomeItem;
import dev.shadowsoffire.apotheosis.ench.objects.ImprovedScrappingTomeItem;
import dev.shadowsoffire.apotheosis.ench.objects.ScrappingTomeItem;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.Tags;
import java.util.stream.Collector;
import java.util.function.Function;
import java.util.stream.Collectors;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import java.util.Map;
import net.minecraft.world.item.Items;
import net.minecraftforge.event.AnvilUpdateEvent;

public class EnchModuleEvents
{
    @SubscribeEvent
    public void anvilEvent(final AnvilUpdateEvent e) {
        if (e.getLeft().m_41793_()) {
            if (e.getRight().m_41720_() == Items.f_41863_) {
                final ItemStack stack = e.getLeft().m_41777_();
                EnchantmentHelper.m_44865_((Map)EnchantmentHelper.m_44831_(stack).entrySet().stream().filter(ent -> ent.getKey().m_6589_()).collect(Collectors.toMap((Function<? super Object, ?>)Map.Entry::getKey, (Function<? super Object, ?>)Map.Entry::getValue)), stack);
                e.setCost(1);
                e.setMaterialCost(1);
                e.setOutput(stack);
            }
            else if (e.getRight().m_41720_() == Ench.Items.PRISMATIC_WEB.get()) {
                final ItemStack stack = e.getLeft().m_41777_();
                EnchantmentHelper.m_44865_((Map)EnchantmentHelper.m_44831_(stack).entrySet().stream().filter(ent -> !ent.getKey().m_6589_()).collect(Collectors.toMap((Function<? super Object, ?>)Map.Entry::getKey, (Function<? super Object, ?>)Map.Entry::getValue)), stack);
                e.setCost(30);
                e.setMaterialCost(1);
                e.setOutput(stack);
                return;
            }
        }
        if ((e.getLeft().m_41720_() == Items.f_42147_ || e.getLeft().m_41720_() == Items.f_42148_) && e.getRight().m_204117_(Tags.Items.STORAGE_BLOCKS_IRON)) {
            if (e.getLeft().m_41613_() != 1) {
                return;
            }
            final int dmg = (e.getLeft().m_41720_() == Items.f_42148_) ? 2 : 1;
            final ItemStack out = new ItemStack((ItemLike)((dmg == 1) ? Items.f_42146_ : Items.f_42147_));
            EnchantmentHelper.m_44865_(EnchantmentHelper.m_44831_(e.getLeft()), out);
            out.m_41764_(1);
            e.setOutput(out);
            e.setCost(5 + e.getLeft().getAllEnchantments().entrySet().stream().mapToInt(ent -> ent.getValue() * (ent.getKey().m_44699_().ordinal() + 1)).sum());
            e.setMaterialCost(1);
        }
        else {
            if (ScrappingTomeItem.updateAnvil(e)) {
                return;
            }
            if (ImprovedScrappingTomeItem.updateAnvil(e)) {
                return;
            }
            if (ExtractionTomeItem.updateAnvil(e)) {
                return;
            }
        }
    }
    
    @SubscribeEvent
    public void repairEvent(final AnvilRepairEvent e) {
        if (ExtractionTomeItem.updateRepair(e)) {
            return;
        }
    }
    
    @SubscribeEvent(priority = EventPriority.LOW)
    public void drops(final LivingDropsEvent e) throws Throwable {
        final Entity 7639_ = e.getSource().m_7639_();
        if (7639_ instanceof final Player p) {
            ((ScavengerEnchant)Ench.Enchantments.SCAVENGER.get()).drops(p, e);
            ((SpearfishingEnchant)Ench.Enchantments.SPEARFISHING.get()).addFishes(e);
        }
    }
    
    @SubscribeEvent(priority = EventPriority.LOWEST)
    public void dropsLowest(final LivingDropsEvent e) {
        final Entity 7639_ = e.getSource().m_7639_();
        if (7639_ instanceof final Player p) {
            ((KnowledgeEnchant)Ench.Enchantments.KNOWLEDGE.get()).drops(p, e);
        }
    }
    
    @SubscribeEvent(priority = EventPriority.LOW)
    public void healing(final LivingHealEvent e) {
        if (e.getEntity().m_6095_() == EntityType.f_20529_) {
            return;
        }
        ((LifeMendingEnchant)Ench.Enchantments.LIFE_MENDING.get()).lifeMend(e);
    }
    
    @SubscribeEvent(priority = EventPriority.LOW)
    public void block(final ShieldBlockEvent e) {
        ((ReflectiveEnchant)Ench.Enchantments.REFLECTIVE.get()).reflect(e);
    }
    
    @SubscribeEvent
    public void looting(final LootingLevelEvent e) {
        final DamageSource src = e.getDamageSource();
        if (src != null) {
            final Entity 7640_ = src.m_7640_();
            if (7640_ instanceof final ThrownTrident trident) {
                final ItemStack triStack = ((TridentGetter)trident).getTridentItem();
                e.setLootingLevel(triStack.getEnchantmentLevel(Enchantments.f_44982_));
            }
        }
    }
    
    @SubscribeEvent
    public void breakSpeed(final PlayerEvent.BreakSpeed e) {
        ((StableFootingEnchant)Ench.Enchantments.STABLE_FOOTING.get()).breakSpeed(e);
    }
    
    @SubscribeEvent(priority = EventPriority.LOW)
    public void breakSpeedLow(final PlayerEvent.BreakSpeed e) {
        ((MinersFervorEnchant)Ench.Enchantments.MINERS_FERVOR.get()).breakSpeed(e);
    }
    
    @SubscribeEvent(priority = EventPriority.LOW)
    public void breakSpeed(final BlockEvent.BreakEvent e) {
        ((EarthsBoonEnchant)Ench.Enchantments.EARTHS_BOON.get()).provideBenefits(e);
        ((ChainsawEnchant)Ench.Enchantments.CHAINSAW.get()).chainsaw(e);
    }
    
    @SubscribeEvent
    public void rightClick(final PlayerInteractEvent.RightClickBlock e) {
        ((NaturesBlessingEnchant)Ench.Enchantments.NATURES_BLESSING.get()).rightClick(e);
    }
    
    @SubscribeEvent(priority = EventPriority.LOWEST)
    public void applyUnbreaking(final AnvilRepairEvent e) {
        final AbstractContainerMenu f_36096_ = e.getEntity().f_36096_;
        if (f_36096_ instanceof final AnvilMenu anvMenu) {
            anvMenu.f_39770_.m_39292_((level, pos) -> {
                final BlockEntity patt6975$temp = level.m_7702_(pos);
                if (patt6975$temp instanceof final AnvilTile anvil) {
                    e.setBreakChance(e.getBreakChance() / (anvil.getEnchantments().getInt((Object)Enchantments.f_44986_) + 1));
                }
            });
        }
    }
    
    @SubscribeEvent(priority = EventPriority.LOW)
    public void livingHurt(final LivingHurtEvent e) {
        ((BerserkersFuryEnchant)Ench.Enchantments.BERSERKERS_FURY.get()).livingHurt(e);
    }
    
    public interface TridentGetter
    {
        ItemStack getTridentItem();
    }
}
